<template>
  <v-container>
    <v-row v-if="!feedback">
      <v-col>
        <v-alert type="info">
          This submission hasn't been corrected due to this being a pass only exam.
        </v-alert>
      </v-col>
    </v-row>
    <v-row v-if="feedback && !feedback.isFinal">
      <v-col>
        <v-alert type="info">
          This feedback is not final! Changes will likely occur!
        </v-alert>
      </v-col>
    </v-row>
    <v-row>
      <v-col :md="solutionHidden ? 12 : 6">
        <base-annotated-submission>
          <template #header>
            <annotated-submission-top-toolbar
              v-if="feedback"
              v-model="mathIsRendered"
              :score="feedback.score"
              :notebook-available="notebookAvailable"
              :submission="submission"
              :submission-type="submissionType"
              :feedback="feedback"
              :is-markdown="isMarkdown"
            />
          </template>
          <template #table-content>
            <tr
              v-for="(code, lineNo) in submissionText"
              :key="lineNo"
            >
              <math-renderer :enabled="mathIsRendered">
                <submission-line
                  :code="code"
                  :line-no="lineNo"
                >
                  <template v-if="feedback">
                    <template v-for="(comment, index) in feedback.feedbackLines[lineNo]">
                      <feedback-comment
                        v-if="showFeedback"
                        :key="comment.pk + index"
                        v-bind="comment"
                        :line-no="lineNo"
                        :show-visibility-icon="false"
                        :corrector-view="false"
                      />
                    </template>
                  </template>
                </submission-line>
              </math-renderer>
            </tr>
          </template>
        </base-annotated-submission>
        <v-card>
          <v-card-title>Labels:</v-card-title>
          <v-card-text>
            <v-row
              v-for="label in mappedLabels"
              :key="'global' + label.pk"
              align="center"
            >
              <v-col sm="6">
                <feedback-label
                  v-bind="label"
                />
              </v-col>
              <v-col sm="6">
                <span><b>Description: </b>{{ label.description }}</span>
              </v-col>
            </v-row>
          </v-card-text>
        </v-card>
        <submission-tests
          :tests="tests"
          :expand="true"
          class="mt-3"
        />
      </v-col>
      <v-col
        class="pl-3"
        lg="6"
        md="12"
      >
        <submission-type
          v-bind="submissionType"
        />
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import { mapState, mapGetters } from 'vuex'
import AnnotatedSubmission from '@/components/submission_notes/SubmissionCorrection'
import SubmissionType from '@/components/submission_type/SubmissionType'
import BaseAnnotatedSubmission from '@/components/submission_notes/base/BaseAnnotatedSubmission'
import AnnotatedSubmissionTopToolbar from '@/components/submission_notes/toolbars/AnnotatedSubmissionTopToolbar'
import SubmissionLine from '@/components/submission_notes/base/SubmissionLine'
import FeedbackComment from '@/components/submission_notes/base/FeedbackComment'
import { StudentPage } from '@/store/modules/student-page'
import { SubmissionNotes } from '@/store/modules/submission-notes'
import SubmissionTests from '@/components/SubmissionTests'
import { FeedbackLabels } from '@/store/modules/feedback-labels'
import FeedbackLabel from '@/components/feedback_labels/FeedbackLabel.vue'
import { fetchNotebookSubmissionAsHtml } from '@/api.ts'
import store from '@/store/store'
import { SubmissionType as SubType } from '@/models'
import { UI } from '@/store/modules/ui'
import MathRenderer from '@/components/MathRenderer.vue'

export default {
  name: 'StudentSubmissionPage',
  components: {
    SubmissionTests,
    FeedbackComment,
    SubmissionLine,
    BaseAnnotatedSubmission,
    AnnotatedSubmissionTopToolbar,
    FeedbackLabel,
    SubmissionType,
    MathRenderer },
  data () {
    return {
      originalSubmissionDialog: false,
      originalSubmission: '',
      mathIsRendered: false,
    }
  },
  computed: {
    id: function () {
      return this.$route.params.id
    },
    isMarkdown () {
      const typePk = SubmissionNotes.state.submission.type
      const type = store.state.submissionTypes[typePk]
      return type && type.programmingLanguage === SubType.ProgrammingLanguageEnum.Markdown
    },
    submissionText () { return SubmissionNotes.submission },
    tests () { return SubmissionNotes.state.submission.tests },
    showFeedback: function (state) { return SubmissionNotes.state.ui.showFeedback },
    submission () { return StudentPage.state.submissionData[this.id] },
    submissionType () { return StudentPage.state.submissionData[this.id].type },
    feedback () { return StudentPage.state.submissionData[this.$route.params.id].feedback },
    mappedLabels () {
      if (!this.feedback) {
        return []
      }
      return this.feedback.labels.map(entry => {
        return FeedbackLabels.state.labels.find(label => {
          return label.pk === entry
        })
      })
    },
    notebookAvailable () {
      return this.submission.sourceCodeAvailable
    },
    solutionHidden () {
      return UI.state.showSubmissionType === false
    }
  },
  mounted () {
    this.onRouteMountOrUpdate(this.id)
  },
  methods: {
    onRouteMountOrUpdate (routeId) {
      StudentPage.SET_VISITED({ index: routeId, visited: true })
      let submission = {...StudentPage.state.submissionData[routeId]}
      submission.type = submission.type.pk
      SubmissionNotes.SET_SUBMISSION(submission)
      this.mathIsRendered = true
    },
  },
  beforeRouteUpdate (to, from, next) {
    this.onRouteMountOrUpdate(to.params.id)
    next()
  }
}
</script>


<style scoped>
.origNotebookFrame {
  width: 100%;
  height: 800px;
}

.v-alert {
  margin: 0;
}
</style>
